unit Unit1;

interface

uses
  Windows, Messages, {Variants,} Classes, SysUtils, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Item1Edit: TEdit;
    Item2Edit: TEdit;
    Item3Edit: TEdit;
    Item4Edit: TEdit;
    Item5Edit: TEdit;
    Item6Edit: TEdit;
    ListenButton: TButton;
    SortingButton: TButton;
    EvaluateButton: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button1: TButton;
    MessageLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ListenButtonClick(Sender: TObject);
    procedure SortingButtonClick(Sender: TObject);
    procedure EvaluateButtonClick(Sender: TObject);
    //
    procedure PlayWave(Filename: string);
    procedure Button1Click(Sender: TObject);
    //
    function GetLeftDesc(n: Integer) : string;
    function GetRightDesc(n: Integer) : string;

  private
    { Private 錾 }
    function GetTitle(n: Integer) : string;
    function GetDescription(n: Integer) : string;
    function GetComment(n: Integer) : string;
    procedure SetRank(n: Integer; r: Integer);
    function GetRank(n: Integer) : Integer;
    //
    function GetWorkloadValue(task: Integer; item: Integer) : Integer;
    procedure SetWorkloadValue(task: Integer; item: Integer; value: Integer);
    procedure ResetWorkLoadValues;
    //
  public
    UseReheasal: Integer;
    TaskCount: Integer;
    { Public 錾 }
    property ItemTitles[n:Integer] : string
      read GetTitle;
    property ItemDescriptions[n:Integer] : string
      read GetDescription;
    property ItemComments[n:Integer] : string
      read GetComment;
    property ItemRanks[n:Integer] : Integer
      read GetRank write SetRank;

    property WorkloadValues[task: Integer; item: Integer] : Integer
      read GetWorkloadValue
      write SetWorkloadValue;

    procedure DoReset;
  end;

var
  Form1: TForm1;
  CurrItem: Integer;
  Descriptions:      array [1..6] of string;
  Comments:          array [1..6] of string;
  Titles:            array [1..6] of string;
  //
  LeftDescs:         array [1..6] of string;
  RightDescs:        array [1..6] of string;
  //
  WaveFiles:         array [1..6] of string;
  Rank:              array [1..6] of Integer;
  TheWorkLoadValues: array [0..4, 1..6] of Integer;
  // task(0:Rehersal), Item

  ListenDone : Boolean; // 6ڂ̉𕷂

implementation

{$R *.dfm}

uses mmsystem, Unit2, Unit3, Unit4;

function TForm1.GetWorkloadValue(task: Integer; item: Integer) : Integer;
begin
  GetWorkloadValue := TheWorkLoadValues[task, item];
end;

procedure TForm1.SetWorkloadValue(task: Integer; item: Integer; value: Integer);
begin
  TheWorkLoadValues[task, item] := value;
end;

function TForm1.GetTitle(n: Integer) : string;
begin
  if (n = 0) or (n > 6) then
    GetTitle := 'xxx'
  else
    GetTitle := Titles[n];
end;

function TForm1.GetDescription(n: Integer) : string;
begin
  if (n = 0) or (n > 6) then
    GetDescription := 'xxx'
  else
    GetDescription := Descriptions[n];
end;

function TForm1.GetComment(n: Integer) : string;
begin
  if (n = 0) or (n > 6) then
    GetComment := 'xxx'
  else
    GetComment := Comments[n];
end;

procedure TForm1.SetRank(n: Integer; r: Integer);
begin
  Rank[n] := r;
end;

function TForm1.GetRank(n: Integer) : Integer;
begin
  GetRank := Rank[n];
end;

procedure TForm1.PlayWave(Filename: string);
var path: string;
begin
  path := ExtractFilePath(Application.ExeName)
    + '\WAV\' + Filename;
  PlaySound(PChar(path), 0, SND_ASYNC);
end;

procedure TForm1.ListenButtonClick(Sender: TObject);
begin
  CurrItem := CurrItem + 1;
  if CurrItem > 6 then begin
    CurrItem := 1;
    ListenDone := true;
    ShowMessage('ʌɐił');
  end;
  case CurrItem of
    1: begin
      Item6Edit.Color := clWhite;
      Item1Edit.Color := clRed;
    end;
    2: begin
      Item1Edit.Color := clWhite;
      Item2Edit.Color := clRed;
    end;
    3: begin
      Item2Edit.Color := clWhite;
      Item3Edit.Color := clRed;
    end;
    4: begin
      Item3Edit.Color := clWhite;
      Item4Edit.Color := clRed;
    end;
    5: begin
      Item4Edit.Color := clWhite;
      Item5Edit.Color := clRed;
    end;
    6: begin
      Item5Edit.Color := clWhite;
      Item6Edit.Color := clRed;
    end;
  end;
  Edit1.Text := Titles[CurrItem];
  Memo1.Text := Descriptions[CurrItem];
  Memo2.Text := Comments[CurrItem];
  ListenButton.Caption := '̐';

  if not ListenDone then begin
    PlayWave(WaveFiles[CurrItem]);
  end;

  if (1 <= CurrItem) and (CurrItem <= 5) then begin
    MessageLabel.Caption := 'Iu̐vĂB';
  end else begin
    MessageLabel.Caption := '';
  end;

end;

procedure TForm1.SortingButtonClick(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // I
  Form4.UpdateResult;
  Form4.Show;
end;

procedure TForm1.EvaluateButtonClick(Sender: TObject);
begin
  Form3.SetTaskId(TButton(Sender).Tag); // 0 or 1..4
  Form3.Show;
end;


procedure TForm1.ResetWorkLoadValues;
var
  task : Integer;
  item : Integer;
  
begin
  //
  for task := 0 to 4 do
    for item := 1 to 6 do
      WorkLoadValues[task, item] := 50;
end;

function TForm1.GetLeftDesc(n: Integer) : string;
begin
  GetLeftDesc := LeftDescs[n];
end;


function TForm1.GetRightDesc(n: Integer) : string;
begin
  GetRightDesc := RightDescs[n];
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  i: Integer;
  s: string;
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  Form1.Caption := 'NASA-TLX for KIKI (101027)';
  for i := 1 to 6 do begin
    s := 'Item' + IntToStr(i);
    Titles[i] := IniFile.ReadString(s, 'Title', '');
    Descriptions[i] := IniFile.ReadString(s, 'Description', '');
    Comments[i] := IniFile.ReadString(s, 'Comment', '');
    WaveFiles[i] := IniFile.ReadString(s, 'WaveFile', '');
    LeftDescs[i] := IniFile.ReadString(s, 'LeftDesc', '');
    RightDescs[i] := IniFile.ReadString(s, 'RightDesc', '');
  end;
  UseReheasal := IniFile.ReadInteger('kikiwwl', 'UseReheasal', 1);
  if UseReheasal = 0 then begin
    EvaluateButton.Visible := False;
  end;
  TaskCount := IniFile.ReadInteger('kikiwwl', 'TaskCount', 4);
  case TaskCount of
    1:
    begin
      Button4.Visible := True;
      Button5.Visible := False;
      Button6.Visible := False;
      Button7.Visible := False;
    end;
    2:
    begin
      Button4.Visible := True;
      Button5.Visible := True;
      Button6.Visible := False;
      Button7.Visible := False;
    end;
    3:
    begin
      Button4.Visible := True;
      Button5.Visible := True;
      Button6.Visible := True;
      Button7.Visible := False;
    end;
    else
    begin
      Button4.Visible := True;
      Button5.Visible := True;
      Button6.Visible := True;
      Button7.Visible := True;
    end;
  end;

  IniFile.Destroy;
  DoReset;
end;

procedure TForm1.DoReset;
begin
  //
  ResetWorkLoadValues;
  MessageLabel.Caption := '';
  CurrItem := 0;
  ListenDone := false;
  Item1Edit.Text := Titles[1];
  Item2Edit.Text := Titles[2];
  Item3Edit.Text := Titles[3];
  Item4Edit.Text := Titles[4];
  Item5Edit.Text := Titles[5];
  Item6Edit.Text := Titles[6];
end;

end.
