unit Unit2;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    CloseButton: TButton;
    GroupBox1: TGroupBox;
    HelpMemo: TMemo;
    DescMemo: TMemo;
    L1Button: TButton;
    R1Button: TButton;
    L2Button: TButton;
    R2Button: TButton;
    L3Button: TButton;
    R3Button: TButton;
    L4Button: TButton;
    R4Button: TButton;
    L5Button: TButton;
    R5Button: TButton;
    L6Button: TButton;
    R6Button: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CommentMemo: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CancelLeftButton: TButton;

    procedure CloseButtonClick(Sender: TObject);
    procedure LeftButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RightButtonClick(Sender: TObject);
    procedure SetLeftButtonsEnabled(b : Boolean);
    procedure SetRightButtonsEnabled(b : Boolean);
    procedure SetEmptyButtonEnabled(btn : TButton);
    procedure SetEmptyButtonDisabled(btn : TButton);
    procedure SetEmptyButtonsDisabled;
    procedure SetEmptyButtonsEnabled;
    procedure SetLeftEmptyButtonsDisabled;
    procedure SetRightEmptyButtonsEnabled;
    procedure HideRightFilledButtons;
    procedure HideFilledButton(btn : TButton);
    procedure ShowRightButtons;
    procedure CancelLeftButtonClick(Sender: TObject);
    
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure DoReset;
  end;

var
  Form2: TForm2;
  LeftSelButton: TButton;
  LeftSelIndex: Integer;
  RightSelButton: TButton;
  RightSelIndex: Integer;
  LeftItems:  array [1..6] of Integer = (1, 2, 3, 4, 5, 6);
  RightItems: array [1..6] of Integer = (0, 0, 0, 0, 0, 0);

implementation

{$R *.dfm}

uses Unit1;

procedure TForm2.FormCreate(Sender: TObject);
begin
  DoReset;
end;

procedure TForm2.SetLeftButtonsEnabled(b : Boolean);
begin
  L1Button.Enabled := b;
  L2Button.Enabled := b;
  L3Button.Enabled := b;
  L4Button.Enabled := b;
  L5Button.Enabled := b;
  L6Button.Enabled := b;
end;

procedure TForm2.SetRightButtonsEnabled(b : Boolean);
begin
  R1Button.Enabled := b;
  R2Button.Enabled := b;
  R3Button.Enabled := b;
  R4Button.Enabled := b;
  R5Button.Enabled := b;
  R6Button.Enabled := b;
end;

procedure TForm2.SetEmptyButtonEnabled(btn : TButton);
begin
  if btn.Caption = '-' then
    btn.Enabled := true
  else
    btn.Enabled := false;
end;

procedure TForm2.SetEmptyButtonDisabled(btn : TButton);
begin
  if btn.Caption = '-' then
    btn.Enabled := false
  else
    btn.Enabled := true;
end;

procedure TForm2.SetEmptyButtonsDisabled;
begin
  SetEmptyButtonDisabled(L1Button);
  SetEmptyButtonDisabled(L2Button);
  SetEmptyButtonDisabled(L3Button);
  SetEmptyButtonDisabled(L4Button);
  SetEmptyButtonDisabled(L5Button);
  SetEmptyButtonDisabled(L6Button);
  //
  SetEmptyButtonDisabled(R1Button);
  SetEmptyButtonDisabled(R2Button);
  SetEmptyButtonDisabled(R3Button);
  SetEmptyButtonDisabled(R4Button);
  SetEmptyButtonDisabled(R5Button);
  SetEmptyButtonDisabled(R6Button);
end;

procedure TForm2.SetEmptyButtonsEnabled;
begin
  SetEmptyButtonEnabled(L1Button);
  SetEmptyButtonEnabled(L2Button);
  SetEmptyButtonEnabled(L3Button);
  SetEmptyButtonEnabled(L4Button);
  SetEmptyButtonEnabled(L5Button);
  SetEmptyButtonEnabled(L6Button);
  SetEmptyButtonEnabled(R1Button);
  SetEmptyButtonEnabled(R2Button);
  SetEmptyButtonEnabled(R3Button);
  SetEmptyButtonEnabled(R4Button);
  SetEmptyButtonEnabled(R5Button);
  SetEmptyButtonEnabled(R6Button);
end;

procedure TForm2.SetLeftEmptyButtonsDisabled;
begin
  SetEmptyButtonDisabled(L1Button);
  SetEmptyButtonDisabled(L2Button);
  SetEmptyButtonDisabled(L3Button);
  SetEmptyButtonDisabled(L4Button);
  SetEmptyButtonDisabled(L5Button);
  SetEmptyButtonDisabled(L6Button);
end;

procedure TForm2.SetRightEmptyButtonsEnabled;
begin
  SetEmptyButtonEnabled(R1Button);
  SetEmptyButtonEnabled(R2Button);
  SetEmptyButtonEnabled(R3Button);
  SetEmptyButtonEnabled(R4Button);
  SetEmptyButtonEnabled(R5Button);
  SetEmptyButtonEnabled(R6Button);
end;

procedure TForm2.HideFilledButton(btn : TButton);
begin
  //
  if btn.Caption = '-' then
    btn.Font.Style := []
  else
    btn.Font.Style := [fsStrikeOut];
end;

procedure TForm2.HideRightFilledButtons;
begin
  //
  HideFilledButton(R1Button);
  HideFilledButton(R2Button);
  HideFilledButton(R3Button);
  HideFilledButton(R4Button);
  HideFilledButton(R5Button);
  HideFilledButton(R6Button);
end;

procedure TForm2.ShowRightButtons;
begin
  //
  R1Button.Font.Style := [];
  R2Button.Font.Style := [];
  R3Button.Font.Style := [];
  R4Button.Font.Style := [];
  R5Button.Font.Style := [];
  R6Button.Font.Style := [];
end;

procedure TForm2.CancelLeftButtonClick(Sender: TObject);
begin
  // ILZ
  if LeftSelButton <> nil then begin
    LeftSelButton.Font.Style := [];
    LeftSelButton := nil;
    LeftSelIndex := 0;
  end;
  // EI{^L
  SetRightButtonsEnabled(True);
  ShowRightButtons;
  // uIv{^𖳌
  CancelLeftButton.Enabled := False;
end;

procedure TForm2.DoReset;
begin
  // {^
  LeftSelButton := nil;
  LeftSelIndex := 0;
  L1Button.Caption := Form1.ItemTitles[1];
  L2Button.Caption := Form1.ItemTitles[2];
  L3Button.Caption := Form1.ItemTitles[3];
  L4Button.Caption := Form1.ItemTitles[4];
  L5Button.Caption := Form1.ItemTitles[5];
  L6Button.Caption := Form1.ItemTitles[6];
  // E{^
  RightSelButton := nil;
  RightSelIndex := 0;
  R1Button.Caption := '-';
  R2Button.Caption := '-';
  R3Button.Caption := '-';
  R4Button.Caption := '-';
  R5Button.Caption := '-';
  R6Button.Caption := '-';
  SetEmptyButtonsDisabled;
end;

procedure TForm2.CloseButtonClick(Sender: TObject);
begin
  Form2.Close;
end;

procedure TForm2.LeftButtonClick(Sender: TObject);
var
  tag : Integer;
  item : Integer;
begin
  // Ă{^LZ
  if LeftSelButton <> nil then begin
    LeftSelButton.Font.Style := [];
    LeftSelButton := nil;
    LeftSelIndex := 0;
  end;

  // empty łȂ{^ꂽ
  if TButton(Sender).Caption <> '-' then begin
    tag := TButton(Sender).tag;
    LeftSelIndex := tag;
    LeftSelButton := TButton(Sender);
    LeftSelButton.Font.Style := [fsBold];
    SetLeftEmptyButtonsDisabled;
    SetRightEmptyButtonsEnabled;
    HideRightFilledButtons;
    //
    item := LeftItems[tag];
    DescMemo.Text := Form1.ItemDescriptions[item];
    CommentMemo.Text := Form1.ItemComments[item];
  end;

  // ̃LZCl[u
  CancelLeftButton.Enabled := True;
end;

procedure TForm2.RightButtonClick(Sender: TObject);
var
  target : TButton;
  pos : Integer;
  left : Integer;
begin
  // E{^NbNF
  // łɍ{^Ă
  //   then EɈڂ
  // łɉE{^Ă
  //   then Ȃ
  // ĂȂ
  //   then ɖ߂

  if LeftSelButton <> nil then begin
    // \
    TButton(Sender).Caption := LeftSelButton.Caption;
    LeftSelButton.Caption := '-';
    LeftSelButton.Font.Style := [];
    // CfbNẌړ
    // E{^tag11-16
    pos := TButton(Sender).tag - 10;
    RightItems[pos] := LeftItems[LeftSelIndex];
    LeftItems[LeftSelIndex] := 0;
    //
    LeftSelButton := nil;
    LeftSelIndex := 0;
    SetEmptyButtonsDisabled;
  end
  else if RightSelButton <> nil then begin
    //
  end
  else begin
    if TButton(Sender).Caption <> '-' then begin
      left := 0;
      if L1Button.Caption = '-' then begin
        target := L1Button; left := 1
      end
      else if L2Button.Caption = '-' then begin
        target := L2Button; left := 2
      end
      else if L3Button.Caption = '-' then begin
        target := L3Button; left := 3
      end
      else if L4Button.Caption = '-' then begin
        target := L4Button; left := 4
      end
      else if L5Button.Caption = '-' then begin
        target := L5Button; left := 5
      end
      else if L6Button.Caption = '-' then begin
        target := L6Button; left := 6
      end
      else
        target := nil;
      if target <> nil then begin
        target.Caption := TButton(Sender).Caption;
        TButton(Sender).Caption := '-';
        SetEmptyButtonsDisabled;
        // CfbNẌړ
        // E{^tag11-16
        pos := TButton(Sender).tag - 10;
        assert(pos <> 0);
        assert(left <> 0);
        LeftItems[left] := RightItems[pos];
        RightItems[pos] := 0;
        //
        DescMemo.Text := '';
      end;
    end;
  end;
  ShowRightButtons;

  // SĂ̑IIH
  if (RightItems[1] * RightItems[2]
    * RightItems[3] * RightItems[4]
    * RightItems[5] * RightItems[6] <> 0) then begin
      CloseButton.Caption := 'I';
      Form1.ItemRanks[RightItems[1]] := 1;
      Form1.ItemRanks[RightItems[2]] := 2;
      Form1.ItemRanks[RightItems[3]] := 3;
      Form1.ItemRanks[RightItems[4]] := 4;
      Form1.ItemRanks[RightItems[5]] := 5;
      Form1.ItemRanks[RightItems[6]] := 6;
    end
  else begin
    CloseButton.Caption := '*****';
  end;

  // LZ{^𖳌
  CancelLeftButton.Enabled := False;

end;

end.
