unit Unit3;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm3 = class(TForm)
    CurrValueScrollBar: TScrollBar;
    CurrValueEdit: TEdit;
    ValueRScrollBar: TScrollBar;
    ValueAScrollBar: TScrollBar;
    ValueBScrollBar: TScrollBar;
    ValueCScrollBar: TScrollBar;
    ValueDScrollBar: TScrollBar;
    GroupBox1: TGroupBox;
    ItemNameEdit: TEdit;
    DescRightEdit: TEdit;
    DescLeftEdit: TEdit;
    NextItemButton: TButton;
    CloseButton: TButton;
    PrevItemButton: TButton;
    ValueREdit: TEdit;
    ValueAEdit: TEdit;
    ValueBEdit: TEdit;
    ValueCEdit: TEdit;
    ValueDEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    DescEdit: TMemo;
    CommentEdit: TMemo;
    Label7: TLabel;
    procedure CurrValueScrollBarChange(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure SetTaskId(n: Integer);
    procedure FormCreate(Sender: TObject);
    procedure PrevItemButtonClick(Sender: TObject);
    procedure NextItemButtonClick(Sender: TObject);
    procedure ValueRScrollBarChange(Sender: TObject);
    procedure ValueAScrollBarChange(Sender: TObject);
    procedure ValueBScrollBarChange(Sender: TObject);
    procedure ValueCScrollBarChange(Sender: TObject);
    procedure ValueDScrollBarChange(Sender: TObject);
    procedure SetTaskRVisible(v : Boolean);
    procedure SetTaskAVisible(v : Boolean);
    procedure SetTaskBVisible(v : Boolean);
    procedure SetTaskCVisible(v : Boolean);
    procedure SetTaskDVisible(v : Boolean);
  private
    { Private 錾 }
    procedure SetPositions;
    procedure ShowItemInfo;
    //
  public
    { Public 錾 }
    procedure DoReset;
  end;

var
  Form3: TForm3;
  TaskId: Integer;
  ItemId: Integer;

implementation

{$R *.dfm}

uses Unit1;

procedure TForm3.ShowItemInfo;
begin
  ItemNameEdit.Text  := Form1.ItemTitles[ItemId];
  DescLeftEdit.Text  := Form1.GetLeftDesc(ItemId);
  DescRightEdit.Text := Form1.GetRightDesc(ItemId);
  DescEdit.Text := Form1.ItemDescriptions[ItemId];
  CommentEdit.Text := Form1.ItemComments[ItemId];
end;

procedure TForm3.DoReset;
begin
  //
  TaskId := 0;
  ItemId := 1;
end;


procedure TForm3.FormCreate(Sender: TObject);
begin
  DoReset;
  //
  // DescRightEdit ̕\Elɂ
  SetWindowLong(DescRightEdit.Handle,GWL_STYLE,
                GetWindowLong(DescRightEdit.Handle,GWL_STYLE)
                or ES_RIGHT
                { or ES_NUMBER } );
  SetWindowPos(DescRightEdit.Handle,0,0,0,0,0,
               SWP_NOMOVE or SWP_NOSIZE or
               SWP_NOZORDER or SWP_FRAMECHANGED);
end;

procedure TForm3.SetTaskRVisible(v : Boolean);
begin
  Label1.Visible := v;
  ValueRScrollBar.Visible := v;
  ValueREdit.Visible := v;
end;

procedure TForm3.SetTaskAVisible(v : Boolean);
begin
  Label2.Visible := v;
  ValueAScrollBar.Visible := v;
  ValueAEdit.Visible := v;
end;

procedure TForm3.SetTaskBVisible(v : Boolean);
begin
  Label3.Visible := v;
  ValueBScrollBar.Visible := v;
  ValueBEdit.Visible := v;
end;

procedure TForm3.SetTaskCVisible(v : Boolean);
begin
  Label4.Visible := v;
  ValueCScrollBar.Visible := v;
  ValueCEdit.Visible := v;
end;

procedure TForm3.SetTaskDVisible(v : Boolean);
begin
  Label5.Visible := v;
  ValueDScrollBar.Visible := v;
  ValueDEdit.Visible := v;
end;

procedure TForm3.SetTaskId(n: Integer);
begin
  //
  if Form1.UseReheasal = 1 then begin
    SetTaskRVisible(true)
  end
  else begin
    SetTaskRVisible(false)
  end;

  TaskId := n;
  if TaskId = 0 then begin
    Label6.Caption := 'R';
    SetTaskAVisible(false);
    SetTaskBVisible(false);
    SetTaskCVisible(false);
    SetTaskDVisible(false);
  end
  else if TaskId = 1 then begin
    Label6.Caption := 'A';
    SetTaskAVisible(true);
    SetTaskBVisible(false);
    SetTaskCVisible(false);
    SetTaskDVisible(false);
  end
  else if TaskId = 2 then begin
    Label6.Caption := 'B';
    SetTaskAVisible(true);
    SetTaskBVisible(true);
    SetTaskCVisible(false);
    SetTaskDVisible(false);
  end
  else if TaskId = 3 then begin
    Label6.Caption := 'C';
    SetTaskAVisible(true);
    SetTaskBVisible(true);
    SetTaskCVisible(true);
    SetTaskDVisible(false);
  end
  else
  if TaskId = 4 then begin
    Label6.Caption := 'D';
    SetTaskAVisible(true);
    SetTaskBVisible(true);
    SetTaskCVisible(true);
    SetTaskDVisible(true);
  end;
  //
  ShowItemInfo;
  SetPositions;
end;

procedure TForm3.ValueAScrollBarChange(Sender: TObject);
begin
  ValueAScrollBar.Position := StrToInt(ValueAEdit.Text);
end;

procedure TForm3.ValueBScrollBarChange(Sender: TObject);
begin
  ValueBScrollBar.Position := StrToInt(ValueBEdit.Text);
end;

procedure TForm3.ValueCScrollBarChange(Sender: TObject);
begin
  ValueCScrollBar.Position := StrToInt(ValueCEdit.Text);
end;

procedure TForm3.ValueDScrollBarChange(Sender: TObject);
begin
  ValueDScrollBar.Position := StrToInt(ValueDEdit.Text);
end;

procedure TForm3.ValueRScrollBarChange(Sender: TObject);
begin
  ValueRScrollBar.Position := StrToInt(ValueREdit.Text);
end;

procedure TForm3.CloseButtonClick(Sender: TObject);
begin
     Form3.Close;
end;

procedure TForm3.SetPositions;
var
  pos : Integer;
begin
  pos := Form1.WorkloadValues[0, ItemId];
  ValueRScrollBar.Position := pos;
  ValueREdit.Text := IntToStr(pos);

  pos := Form1.WorkloadValues[1, ItemId];
  ValueAScrollBar.Position := pos;
  ValueAEdit.Text := IntToStr(pos);

  pos := Form1.WorkloadValues[2, ItemId];
  ValueBScrollBar.Position := pos;
  ValueBEdit.Text := IntToStr(pos);

  pos := Form1.WorkloadValues[3, ItemId];
  ValueCScrollBar.Position := pos;
  ValueCEdit.Text := IntToStr(pos);

  pos := Form1.WorkloadValues[4, ItemId];
  ValueDScrollBar.Position := pos;
  ValueDEdit.Text := IntToStr(pos);

  pos := Form1.WorkloadValues[TaskId, ItemId];
  CurrValueScrollBar.Position := pos;
  CurrValueEdit.Text := IntToStr(pos);
end;

procedure TForm3.NextItemButtonClick(Sender: TObject);
//var
//  pos : Integer;
begin
  //
  ItemId := ItemId + 1;
  if ItemId > 6 then begin
    ItemId := 1;
    ShowMessage('ꂳ܂ł');
    Form3.Close;
  end
  else begin
    CurrValueScrollBar.SetFocus;
  end;
  //
  ShowItemInfo;
  SetPositions;
end;

procedure TForm3.PrevItemButtonClick(Sender: TObject);
begin
  //
  ItemId := ItemId - 1;
  if ItemId < 1 then ItemId := 6;
  //
  ShowItemInfo;
  SetPositions;
end;

procedure TForm3.CurrValueScrollBarChange(Sender: TObject);
var
  pos : Integer;
begin
  pos := CurrValueScrollBar.Position;
  CurrValueEdit.Text := IntToStr(pos);
  //
  Form1.WorkloadValues[TaskId, ItemId] := pos;
  //
  if TaskId = 0 then begin
    ValueRScrollBar.Position := pos;
    ValueREdit.Text := IntToStr(pos);
  end
  else if TaskId = 1 then begin
    ValueAScrollBar.Position := pos;
    ValueAEdit.Text := IntToStr(pos);
  end
  else if TaskId = 2 then begin
    ValueBScrollBar.Position := pos;
    ValueBEdit.Text := IntToStr(pos);
  end
  else if TaskId = 3 then begin
    ValueCScrollBar.Position := pos;
    ValueCEdit.Text := IntToStr(pos);
  end
  else if TaskId = 4 then begin
    ValueDScrollBar.Position := pos;
    ValueDEdit.Text := IntToStr(pos);
  end;
  SetPositions;
end;

end.
