unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm4 = class(TForm)
    CloseButton: TButton;
    ResultMemo: TMemo;
    SaveButton: TButton;
    NameEdit: TEdit;
    SaveDialog1: TSaveDialog;
    ResetButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure UpdateButtonClick(Sender: TObject);
    procedure UpdateResult;
    function RankToWeight(n : Integer) : Integer;
    procedure SaveButtonClick(Sender: TObject);
    procedure NameEditChange(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

uses Unit1, Unit2, Unit3;

procedure TForm4.CloseButtonClick(Sender: TObject);
begin
  Form4.Close;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  //
end;

procedure TForm4.NameEditChange(Sender: TObject);
begin
  UpdateResult;
end;

procedure TForm4.UpdateButtonClick(Sender: TObject);
begin
  UpdateResult;
end;

function TForm4.RankToWeight(n : Integer) : Integer;
begin
  // 1->6
  // 6->1
  RankToWeight := 7 - n;
end;

procedure TForm4.ResetButtonClick(Sender: TObject);
begin
  //
  Form1.DoReset;
  Form2.DoReset;
  Form3.DoReset;
end;

procedure TForm4.SaveButtonClick(Sender: TObject);
begin
  //
  SaveDialog1.FileName := 'wwl-' + NameEdit.Text + '.csv';
  if SaveDialog1.Execute then begin
    //ShowMessage(SaveDialog1.FileName);
    ResultMemo.Lines.SaveToFile(SaveDialog1.FileName);
  end;

end;

procedure TForm4.UpdateResult;
var
  s : string;
  i,j : Integer;
  sum, weight : Real;
  BeginNum: Integer;
begin
  ResultMemo.Lines.Clear;
  ResultMemo.Lines.Add('G,S,MD,PD,TP,EF,FR,AC,M,P,T,E,F,A,SUM,WWL');

  BeginNum := 1;
  if Form1.UseReheasal = 1 then BeginNum := 0;

  for i := BeginNum to Form1.TaskCount do begin
    // calc
    sum := 0.0;
    for j := 1 to 6 do begin
      weight := RankToWeight(Form1.ItemRanks[j]);
      sum := sum + weight * Form1.WorkLoadValues[i,j];
    end;
    // output
    s := NameEdit.Text + ',';
    // s := s + IntToStr(i) + ',';
    if i = 0 then
      s := s + 'R,'
    else if i = 1 then
      s := s + 'A,'
    else if i = 2 then
      s := s + 'B,'
    else if i = 3 then
      s := s + 'C,'
    else if i = 4 then
      s := s + 'D,';

    for j := 1 to 6 do begin
      s := s + IntToStr(Form1.WorkLoadValues[i,j]);
      s := s + ',';
    end;
    for j := 1 to 6 do begin
      s := s + IntToStr(RankToWeight(Form1.ItemRanks[j]));
      s := s + ',';
    end;
    s := s + format('%.f', [sum]);
    s := s + ',' + format('%.2f', [sum / 21.0]); // sum(1..6)
    ResultMemo.Lines.Add(s);
  end;

end;

end.
